ErrorHandler Class Referenceabstract

Appenders may delegate their error handling to `ErrorHandlers`. More...

Inherits OptionHandler.

Inherited by OnlyOnceErrorHandler`[virtual]`, and FallbackErrorHandler`[virtual]`.

## Public Member Functions

virtual | ~ErrorHandler ()
virtual void | setLogger (const LoggerPtr &logger)=0
| Add a reference to a logger to which the failing appender might be attached to. More...
virtual void | error (const LogString &message, const std::exception &e, int errorCode) const =0
| Equivalent to the error(const String&, helpers::Exception&, int, spi::LoggingEvent&) with the the event parameteter set to null. More...
virtual void | error (const LogString &message) const =0
| This method is normally used to just print the error message passed as a parameter. More...
virtual void | error (const LogString &message, const std::exception &e, int errorCode, const LoggingEventPtr &event) const =0
| This method is invoked to handle the error. More...
virtual void | setAppender (const AppenderPtr &appender)=0
| Set the appender for which errors are handled. More...
virtual void | setBackupAppender (const AppenderPtr &appender)=0
| Set the appender to fallback upon in case of failure. More...
Public Member Functions inherited from OptionHandler
virtual | ~OptionHandler ()
virtual void | activateOptions (log4cxx::helpers::Pool &p)=0
| Activate the options that were previously set with calls to option setters. More...
virtual void | setOption (const LogString &option, const LogString &value)=0
| Set `option` to `value`. More...
Public Member Functions inherited from Object
virtual const helpers::Class & | getClass () const
virtual | ~Object ()
virtual void | addRef () const =0
virtual void | releaseRef () const =0
virtual bool | instanceof (const Class &clazz) const =0
virtual const void * | cast (const Class &clazz) const =0

## Additional Inherited Members

Static Public Member Functions inherited from Object
static const helpers::Class & | getStaticClass ()
static const log4cxx::helpers::ClassRegistration & | registerClass ()

## Detailed Description

Appenders may delegate their error handling to `ErrorHandlers`.

Error handling is a particularly tedious to get right because by definition errors are hard to predict and to reproduce.

Please take the time to contact the author in case you discover that errors are not properly handled. You are most welcome to suggest new error handling policies or criticize existing policies.

## Constructor & Destructor Documentation

virtual ~ErrorHandler | ( |  | ) |

inline virtual

## Member Function Documentation

virtual void error | ( | const LogString & | message,
|  | const std::exception & | e,
|  | int | errorCode
| ) |  | const

pure virtual

Equivalent to the error(const String&, helpers::Exception&, int, spi::LoggingEvent&) with the the event parameteter set to null.

Implemented in FallbackErrorHandler, and OnlyOnceErrorHandler.

virtual void error | ( | const LogString & | message | ) | const

pure virtual

This method is normally used to just print the error message passed as a parameter.

Implemented in FallbackErrorHandler, and OnlyOnceErrorHandler.

virtual void error | ( | const LogString & | message,
|  | const std::exception & | e,
|  | int | errorCode,
|  | const LoggingEventPtr & | event
| ) |  | const

pure virtual

This method is invoked to handle the error.

Parameters

  message | The message assoicated with the error.
  e | The Exption that was thrown when the error occured.
  errorCode | The error code associated with the error.
  event | The logging event that the failing appender is asked to log.

Implemented in FallbackErrorHandler, and OnlyOnceErrorHandler.

virtual void setAppender | ( | const AppenderPtr & | appender | ) |

pure virtual

Set the appender for which errors are handled.

This method is usually called when the error handler is configured.

Implemented in FallbackErrorHandler, and OnlyOnceErrorHandler.

virtual void setBackupAppender | ( | const AppenderPtr & | appender | ) |

pure virtual

Set the appender to fallback upon in case of failure.

Implemented in FallbackErrorHandler, and OnlyOnceErrorHandler.

virtual void setLogger | ( | const LoggerPtr & | logger | ) |

pure virtual

Add a reference to a logger to which the failing appender might be attached to.

The failing appender will be searched and replaced only in the loggers you add through this method.

Parameters

  logger | One of the loggers that will be searched for the failing appender in view of replacement.

Implemented in FallbackErrorHandler, and OnlyOnceErrorHandler.

The documentation for this class was generated from the following file:

- errorhandler.h